<template>
	<main>
		<section>
			<h3>Login settings</h3>
			<form @submit.prevent="saveIdent" @change.prevent="saveIdent">
				<label for="identities">Change my primary identity: </label>
				<select class="select" disabled name="identities" :value="primaryIdentity" id="identities" ref="identities">
					<option v-for="(identity, index) in identities" :key="index" :value="identity.id">{{ identity.email }}</option>
				</select>
			</form>

			<h3>Security features</h3>
			<form @submit.prevent="saveIdent" @change.prevent="saveIdent">
				<input class="checkbox" type="checkbox" :checked="disallowNonPrimary" disabled name="disallow" id="disallow" ref="disallow"/>
				<label for="disallow"> Disallow logging in with non-primary identities</label>
				<details>
					<summary title="what's this?">What's this?</summary>
					<p>This option allows you to prevent logging in with any identity other than the one you set as Primary.</p>
					<p>Disabling this option is not recommended.</p>
				</details>
				<br><br>
				<input class="checkbox" type="checkbox" :checked="strictIPCheck" disabled name="strict" id="strict" ref="strict"/>
				<label for="strict"> Deauthenticate when my IP address changes</label>
				<details>
					<summary title="what's this?">What's this?</summary>
					<p>This option will log you out when your IP address changes.</p>
					<p>If the IP address that was used to log in is different than the one currently in use, the server will refuse to authenticate it and require to log in again.</p>
				</details>
				<!-- TODO: require re-entering the email address on authentication -->
			</form>
			<span class="save" ref="save">Saved</span>
		</section>

		<section>
			<h3>Account details</h3>
			<p>Your game account email is <samp><input class="input inline pa_xs" readonly :value="vaultId + '@vault'" /></samp><br>Use this email to perform operations on the rEvolt character selection screen</p>
			<p>Your secondary game account email is <samp><input class="input inline pa_xs" readonly :value="'~steamuser_' + vaultId + '%d@tmw2.org'" /></samp><br>Use this email to perform operations on other servers character selection screen</p>
		</section>

		<section>
			<h3>Support</h3>
			<p>If you encounter errors or need assistance, you may contact our support team at:<br>
			<a :href="links.support" rel="noopener" target="_blank">{{ links.support }}</a></p>
		</section>

		<section>
			<h3>Policies</h3>
			<ul>
				<li><a :href="links.rules" rel="noopener" target="_blank">Game Rules</a></li>
				<li><a :href="links.TSC" rel="noopener" target="_blank">TMW Social Convention (<q>TSC</q>)</a></li>
				<li><a :href="links.TOS" rel="noopener" target="_blank">Terms of Service (<q>TOS</q>)</a></li>
				<li><a :href="links.PRP" rel="noopener" target="_blank">Privacy Policy</a></li>
			</ul>
		</section>

		<section>
			<h3>My data</h3>
			<p>To request an archive or ask for deletion of your personal data:<br>contact us at <a href="mailto:data@themanaworld.org">data@themanaworld.org</a></p>
		</section>

		<!-- TODO: request data, request deletion, set up webauthn, access log -->
	</main>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator"

@Component({
	computed: {
		// NOTE: because of a Vue bug we can't use v-bind:selected on <option>
		identities () {
			return this.$store.state.identities
		},
		disallowNonPrimary () {
			return !this.$store.state.account.allowNonPrimary
		},
		primaryIdentity () {
			return this.$store.state.account.primaryIdentity
		},
		strictIPCheck () {
			return this.$store.state.account.strictIPCheck
		},
		vaultId () {
			return this.$store.state.account.vaultId
		},
	},
})
export default class VaultSettings extends Vue {
	elems = [
		this.$refs.identities as HTMLSelectElement,
		this.$refs.disallow as HTMLInputElement,
		this.$refs.strict as HTMLInputElement,
	]
	links = {
		rules: process.env.VUE_APP_RULES,
		TSC: process.env.VUE_APP_TSC,
		TOS: process.env.VUE_APP_TOS,
		PRP: process.env.VUE_APP_PRP,
		support: process.env.VUE_APP_SUPPORT,
	}

	async beforeMount () {
		const req = new Request(`${process.env.VUE_APP_API}/vault/account`, {
			method: "GET",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		switch (rawResponse.status) {
		default:
			// TODO: handle errors
			break
		case 200:
			this.$store.commit("setAccountData", json.data)
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		}
	}

	async mounted () {
		this.elems = [
			this.$refs.identities as HTMLSelectElement,
			this.$refs.disallow as HTMLInputElement,
			this.$refs.strict as HTMLInputElement,
		]

		for (const elem of this.elems) {
			elem.disabled = false
		}
	}

	async saveIdent (ev: Event) {
		if (!ev.isTrusted) {
			// only save when the player clicks the form
			return
		}

		const indicator = this.$refs.save as HTMLSpanElement

		for (const elem of this.elems) {
			elem.disabled = true
		}

		const data = {
			primary: +(this.elems[0] as HTMLSelectElement).value,
			disallow: !!(this.elems[1] as HTMLInputElement).checked,
			strict: !!(this.elems[2] as HTMLInputElement).checked,
		}

		const req = new Request(`${process.env.VUE_APP_API}/vault/account`, {
			method: "PATCH",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				primary: data.primary,
				allow: !data.disallow,
				strict: data.strict,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		for (const elem of this.elems) {
			elem.disabled = false
		}

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		switch (rawResponse.status) {
		case 200:
			indicator.classList.remove("ok")
			void indicator.offsetWidth // trigger a reflow to force the animation to restart
			indicator.classList.add("ok")

			this.$store.commit("setAccountData", {
				primaryIdentity: data.primary,
				allowNonPrimary: !data.disallow,
				strictIPCheck: data.strict,
			})
			return
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 429:
			// TODO
			return
		case 500:
			// TODO
			return
		case 502:
			// TODO
			return
		default:
			// TODO
			return
		}
	}
}
</script>

<style scoped>
option[selected] {
	font-weight: bold;
}

.save {
	display: block;
	margin: 1ex;
	color: green;
	font-weight: bold;
	opacity: 0;

	&.ok {
		opacity: 0;
		animation: autohide 1s 1;
		animation-timing-function: ease-in;
	}

	&::before {
		content: "[ ";
	}

	&::after {
		content: " ]";
	}
}

samp input[readonly] {
	width: 15ex;
	margin: 1ex;
}

section {
	padding: 1em 1em 1em 1em;
	margin-bottom: 1em;

	& h3:not(:first-of-type) {
		margin-top: 2em;
	}

	& label {
		float: top;
	}

	& details {
		display: inline-block;
		margin-left: 1em;

		& summary {
			display: inline;
			cursor: help;
			color: blue;
			outline: none;
		}

		&:not([open]) summary {
			border: inset 1px blue;
			padding: 1px 2px 1px 2px;
			background: var(--success-1);

			&::-webkit-details-marker {
				display: none;
			}

			&::before {
				content: "";
				width: 16px;
				height: 16px;
				display: inline-block;
				background-image: url(../assets/icons/question-mark-circle.svg);
				margin-right: 0.5ex;
				margin-bottom: -3px;
			}
		}

		&[open] {
			margin: 1em;
			background: gray(80);
			border: blue 1px inset;

			& p, & summary {
				padding: 1ex;
			}
			& summary {
				display: block;
				border-bottom: solid 1px blue;
			}
		}
	}
}

@keyframes autohide {
	0% { opacity: 1 }
	100% { opacity: 0 }
}
</style>
